# ncurses 6.1 - patch 20180630 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.1 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.1 can be found at
# 	ftp://ftp.invisible-island.net/ncurses/6.1
#	http://invisible-mirror.net/archives/ncurses/6.1 
#
# ------------------------------------------------------------------------------
# ftp://ftp.invisible-island.net/ncurses/6.1/ncurses-6.1-20180630.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Jul  1 00:24:49 UTC 2018
# ------------------------------------------------------------------------------
# NEWS                             |   12 +++++++++++-
# VERSION                          |    2 +-
# dist.mk                          |    4 ++--
# man/terminfo.head                |    4 ++--
# misc/terminfo.src                |   32 ++++++++++++++++++--------------
# ncurses/curses.priv.h            |    4 ++--
# ncurses/tinfo/getenv_num.c       |    6 ++++--
# ncurses/tinfo/lib_setup.c        |    6 +++---
# ncurses/widechar/charable.c      |    8 ++++++--
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# progs/tput.c                     |    6 +++---
# 16 files changed, 62 insertions(+), 42 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.3150 
--- ncurses-6.1-20180623+/NEWS	2018-06-24 00:15:39.000000000 +0000
+++ ncurses-6.1-20180630/NEWS	2018-06-30 20:45:08.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.3150 2018/06/24 00:15:39 tom Exp $
+-- $Id: NEWS,v 1.3152 2018/06/30 20:45:08 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,16 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20180630
+	+ add acsc string to vi200 (Nibby Nebbulous)
+	  add right/down-arrow to vi200's acsc -TD
+	+ add "x" to tput's getopt string so that "tput -x clear" works
+	  (Nicholas Marriott).
+	+ minor fixes prompted by anonymous report on stack overflow:
+	  + correct order of checks in _nc_get_locale(), for systems lacking
+	    locale support.
+	  + add "#error" in a few places to flag unsupported configurations
+
 20180623
 	+ use _WIN32/_WIN64 in preference to __MINGW32__/__MINGW64__ symbols
 	  to simplify building with MSVC, since the former are defined in both
Index: VERSION
--- ncurses-6.1-20180623+/VERSION	2018-06-18 20:36:58.000000000 +0000
+++ ncurses-6.1-20180630/VERSION	2018-06-30 15:17:22.000000000 +0000
@@ -1 +1 @@
-5:0:10	6.1	20180623
+5:0:10	6.1	20180630
Index: dist.mk
Prereq:  1.1229 
--- ncurses-6.1-20180623+/dist.mk	2018-06-18 20:36:58.000000000 +0000
+++ ncurses-6.1-20180630/dist.mk	2018-06-30 15:17:22.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1229 2018/06/18 20:36:58 tom Exp $
+# $Id: dist.mk,v 1.1230 2018/06/30 15:17:22 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 1
-NCURSES_PATCH = 20180623
+NCURSES_PATCH = 20180630
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: man/terminfo.head
Prereq:  1.33 
--- ncurses-6.1-20180623+/man/terminfo.head	2018-05-19 20:57:27.000000000 +0000
+++ ncurses-6.1-20180630/man/terminfo.head	2018-05-19 20:57:27.000000000 +0000
@@ -1,5 +1,5 @@
 .\"***************************************************************************
-.\" Copyright (c) 1998-2016,2017 Free Software Foundation, Inc.              *
+.\" Copyright (c) 1998-2017,2018 Free Software Foundation, Inc.              *
 .\"                                                                          *
 .\" Permission is hereby granted, free of charge, to any person obtaining a  *
 .\" copy of this software and associated documentation files (the            *
@@ -26,7 +26,7 @@
 .\" authorization.                                                           *
 .\"***************************************************************************
 .\"
-.\" $Id: terminfo.head,v 1.33 2018/05/19 20:57:27 tom Exp $
+.\" $Id: terminfo.head,v 1.34 2018/05/19 20:57:27 tom Exp $
 .TH terminfo 5 "" "" "File Formats"
 .ds n 5
 .ds d @TERMINFO@
Index: misc/terminfo.src
--- ncurses-6.1-20180623+/misc/terminfo.src	2018-05-19 20:10:26.000000000 +0000
+++ ncurses-6.1-20180630/misc/terminfo.src	2018-06-30 17:32:07.000000000 +0000
@@ -6,8 +6,8 @@
 # Report bugs and new terminal descriptions to
 #	bug-ncurses@gnu.org
 #
-#	$Revision: 1.699 $
-#	$Date: 2018/05/19 20:10:26 $
+#	$Revision: 1.702 $
+#	$Date: 2018/06/30 17:32:07 $
 #
 # The original header is preserved below for reference.  It is noted that there
 # is a "newer" version which differs in some cosmetic details (but actually
@@ -10579,18 +10579,18 @@
 vi200|visual 200,
 	OTbs, OTpt, am, mir, msgr,
 	OTkn#10, cols#80, it#8, lines#24,
-	acsc=, bel=^G, cbt=\Ez, clear=\Ev, cnorm=\Ec, cr=\r, cub1=^H,
-	cud1=\n, cuf1=\EC, cup=\EY%p1%{32}%+%c%p2%{32}%+%c,
-	cuu1=\EA, cvvis=\Ed, dch1=\EO, dim=\E4, dl1=\EM, ed=\Ey,
-	el=\Ex, home=\EH, ht=^I, hts=\E1, il1=\EL, ind=\n, invis=\Ea,
-	kbs=^H, kclr=\Ev, kctab=\E2, kcub1=\ED, kcud1=\EB, kcuf1=\EC,
-	kcuu1=\EA, kdch1=\EO, kdl1=\EM, ked=\EJ, kel=\Et, kf0=\E?p,
-	kf1=\E?q, kf2=\E?r, kf3=\E?s, kf4=\E?t, kf5=\E?u, kf6=\E?v,
-	kf7=\E?w, kf8=\E?x, kf9=\E?y, khome=\EH, khts=\E1, kich1=\Ei,
-	kil1=\EL, krmir=\Ej, mc0=\EH\E], mc4=\EX, mc5=\EW, ri=\EI,
-	rmacs=\EG, rmkx=\E>, rmso=\E3,
-	rs1=\E3\Eb\Ej\E\El\EG\Ec\Ek\EX, sgr0=\E3\Eb, smacs=\EF,
-	smkx=\E=, smso=\E4, tbc=\Eg,
+	acsc=+h.kffggjmkllsmenbq`tnuovcwdxa}r, bel=^G, cbt=\Ez,
+	clear=\Ev, cnorm=\Ec, cr=\r, cub1=^H, cud1=\n, cuf1=\EC,
+	cup=\EY%p1%{32}%+%c%p2%{32}%+%c, cuu1=\EA, cvvis=\Ed,
+	dch1=\EO, dim=\E4, dl1=\EM, ed=\Ey, el=\Ex, home=\EH, ht=^I,
+	hts=\E1, il1=\EL, ind=\n, invis=\Ea, kbs=^H, kclr=\Ev,
+	kctab=\E2, kcub1=\ED, kcud1=\EB, kcuf1=\EC, kcuu1=\EA,
+	kdch1=\EO, kdl1=\EM, ked=\EJ, kel=\Et, kf0=\E?p, kf1=\E?q,
+	kf2=\E?r, kf3=\E?s, kf4=\E?t, kf5=\E?u, kf6=\E?v, kf7=\E?w,
+	kf8=\E?x, kf9=\E?y, khome=\EH, khts=\E1, kich1=\Ei, kil1=\EL,
+	krmir=\Ej, mc0=\EH\E], mc4=\EX, mc5=\EW, ri=\EI, rmacs=\EG,
+	rmkx=\E>, rmso=\E3, rs1=\E3\Eb\Ej\E\El\EG\Ec\Ek\EX,
+	sgr0=\E3\Eb, smacs=\EF, smkx=\E=, smso=\E4, tbc=\Eg,
 # The older Visuals didn't come with function keys. This entry uses
 # <smkx> and <rmkx> so that the keypad keys can be used as function keys.
 # If your version of vi doesn't support function keys you may want
@@ -25744,4 +25744,8 @@
 #	  (report by C Anthony Risinger)
 #	+ improve iterm2 using some xterm features which it has adapted -TD
 #
+# 2018-06-30
+#	+ add acsc string to vi200 (Nibby Nebbulous)
+#	  add right/down-arrow to vi200's acsc -TD
+#
 ######## SHANTIH!  SHANTIH!  SHANTIH!
Index: ncurses/curses.priv.h
Prereq:  1.602 
--- ncurses-6.1-20180623+/ncurses/curses.priv.h	2018-06-23 21:35:06.000000000 +0000
+++ ncurses-6.1-20180630/ncurses/curses.priv.h	2018-06-30 21:59:10.000000000 +0000
@@ -34,7 +34,7 @@
  ****************************************************************************/
 
 /*
- * $Id: curses.priv.h,v 1.602 2018/06/23 21:35:06 tom Exp $
+ * $Id: curses.priv.h,v 1.603 2018/06/30 21:46:25 tom Exp $
  *
  *	curses.priv.h
  *
@@ -71,7 +71,7 @@
 #include <unistd.h>
 #endif
 
-#if HAVE_SYS_BSDTYPES_H
+#if HAVE_SYS_BSDTYPES_H && !(defined(_WIN32) || defined(_WIN64))
 #include <sys/bsdtypes.h>	/* needed for ISC */
 #endif
 
Index: ncurses/tinfo/getenv_num.c
Prereq:  1.6 
--- ncurses-6.1-20180623+/ncurses/tinfo/getenv_num.c	2013-09-28 20:25:08.000000000 +0000
+++ ncurses-6.1-20180630/ncurses/tinfo/getenv_num.c	2018-06-30 19:54:49.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2012,2013 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2013,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -36,7 +36,7 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: getenv_num.c,v 1.6 2013/09/28 20:25:08 tom Exp $")
+MODULE_ID("$Id: getenv_num.c,v 1.7 2018/06/30 19:54:49 tom Exp $")
 
 NCURSES_EXPORT(int)
 _nc_getenv_num(const char *name)
@@ -68,6 +68,8 @@
 	_nc_SPRINTF(buffer, _nc_SLIMIT(sizeof(buffer)) "%s=%d", name, value);
 	if ((s = strdup(buffer)) != 0)
 	    putenv(s);
+#else
+#error expected setenv/putenv functions
 #endif
     }
 }
Index: ncurses/tinfo/lib_setup.c
Prereq:  1.193 
--- ncurses-6.1-20180623+/ncurses/tinfo/lib_setup.c	2018-06-23 21:35:06.000000000 +0000
+++ ncurses-6.1-20180630/ncurses/tinfo/lib_setup.c	2018-06-30 19:40:27.000000000 +0000
@@ -48,7 +48,7 @@
 #include <locale.h>
 #endif
 
-MODULE_ID("$Id: lib_setup.c,v 1.193 2018/06/23 21:35:06 tom Exp $")
+MODULE_ID("$Id: lib_setup.c,v 1.194 2018/06/30 19:40:27 tom Exp $")
 
 /****************************************************************************
  *
@@ -543,9 +543,9 @@
      */
     env = setlocale(LC_CTYPE, 0);
 #else
-    if (((env = getenv("LC_ALL")) != 0 && *env != '\0')
+    if (((env = getenv("LANG")) != 0 && *env != '\0')
 	|| ((env = getenv("LC_CTYPE")) != 0 && *env != '\0')
-	|| ((env = getenv("LANG")) != 0 && *env != '\0')) {
+	|| ((env = getenv("LC_ALL")) != 0 && *env != '\0')) {
 	;
     }
 #endif
Index: ncurses/widechar/charable.c
Prereq:  1.5 
--- ncurses-6.1-20180623+/ncurses/widechar/charable.c	2008-07-05 20:51:41.000000000 +0000
+++ ncurses-6.1-20180630/ncurses/widechar/charable.c	2018-06-30 20:46:25.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 2003-2005,2008 Free Software Foundation, Inc.              *
+ * Copyright (c) 2003-2008,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -32,7 +32,7 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: charable.c,v 1.5 2008/07/05 20:51:41 tom Exp $")
+MODULE_ID("$Id: charable.c,v 1.7 2018/06/30 20:46:25 tom Exp $")
 
 NCURSES_EXPORT(bool) _nc_is_charable(wchar_t ch)
 {
@@ -57,6 +57,8 @@
 	result = UChar(temp[0]);
     else
 	result = -1;
+#else
+#error expected either wctob/wctomb
 #endif
     return result;
 }
@@ -75,6 +77,8 @@
 	result = convert;
     else
 	result = WEOF;
+#else
+#error expected either btowc/mbtowc
 #endif
     return result;
 }
Index: package/debian-mingw/changelog
--- ncurses-6.1-20180623+/package/debian-mingw/changelog	2018-06-18 20:36:58.000000000 +0000
+++ ncurses-6.1-20180630/package/debian-mingw/changelog	2018-06-30 15:17:22.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180623) unstable; urgency=low
+ncurses6 (6.1+20180630) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 18 Jun 2018 16:36:58 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 30 Jun 2018 11:17:22 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.1-20180623+/package/debian-mingw64/changelog	2018-06-18 20:36:58.000000000 +0000
+++ ncurses-6.1-20180630/package/debian-mingw64/changelog	2018-06-30 15:17:22.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180623) unstable; urgency=low
+ncurses6 (6.1+20180630) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 18 Jun 2018 16:36:58 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 30 Jun 2018 11:17:22 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.1-20180623+/package/debian/changelog	2018-06-18 20:36:58.000000000 +0000
+++ ncurses-6.1-20180630/package/debian/changelog	2018-06-30 15:17:22.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180623) unstable; urgency=low
+ncurses6 (6.1+20180630) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 18 Jun 2018 16:36:58 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 30 Jun 2018 11:17:22 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.276 
--- ncurses-6.1-20180623+/package/mingw-ncurses.nsi	2018-06-18 20:36:58.000000000 +0000
+++ ncurses-6.1-20180630/package/mingw-ncurses.nsi	2018-06-30 15:17:22.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.276 2018/06/18 20:36:58 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.277 2018/06/30 15:17:22 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "1"
 !define VERSION_YYYY  "2018"
-!define VERSION_MMDD  "0623"
+!define VERSION_MMDD  "0630"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.1-20180623+/package/mingw-ncurses.spec	2018-06-18 20:36:58.000000000 +0000
+++ ncurses-6.1-20180630/package/mingw-ncurses.spec	2018-06-30 15:17:22.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.1
-Release: 20180623
+Release: 20180630
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.1-20180623+/package/ncurses.spec	2018-06-18 20:36:58.000000000 +0000
+++ ncurses-6.1-20180630/package/ncurses.spec	2018-06-30 15:17:22.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.1
-Release: 20180623
+Release: 20180630
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: progs/tput.c
Prereq:  1.78 
--- ncurses-6.1-20180623+/progs/tput.c	2017-10-14 20:46:43.000000000 +0000
+++ ncurses-6.1-20180630/progs/tput.c	2018-06-30 15:56:01.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2016,2017 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2017,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -50,7 +50,7 @@
 #include <transform.h>
 #include <tty_settings.h>
 
-MODULE_ID("$Id: tput.c,v 1.78 2017/10/14 20:46:43 tom Exp $")
+MODULE_ID("$Id: tput.c,v 1.79 2018/06/30 15:56:01 Nicholas.Marriott Exp $")
 
 #define PUTS(s)		fputs(s, stdout)
 
@@ -293,7 +293,7 @@
 
     term = getenv("TERM");
 
-    while ((c = getopt(argc, argv, "ST:V")) != -1) {
+    while ((c = getopt(argc, argv, "ST:Vx")) != -1) {
 	switch (c) {
 	case 'S':
 	    cmdline = FALSE;
